var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/loaders/css-loader.ts
var css_loader_exports = {};
__export(css_loader_exports, {
  default: () => CssLoader
});
module.exports = __toCommonJS(css_loader_exports);

// node_modules/.pnpm/tsup@5.12.6_postcss@8.4.12+typescript@4.6.3/node_modules/tsup/assets/cjs_shims.js
var getImportMetaUrl = () => typeof document === "undefined" ? new URL("file:" + __filename).href : document.currentScript && document.currentScript.src || new URL("main.js", document.baseURI).href;
var importMetaUrl = /* @__PURE__ */ getImportMetaUrl();

// src/loaders/css-loader.ts
var import_path = require("path");
var import_fs = require("fs");

// src/util.ts
var import_debug = __toESM(require("debug"));
var import_processTailwindFeatures = __toESM(require("tailwindcss/lib/processTailwindFeatures"));
var import_getModuleDependencies = __toESM(require("tailwindcss/lib/lib/getModuleDependencies"));
var import_resolveConfig = __toESM(require("tailwindcss/resolveConfig"));
var import_normalize_path = __toESM(require("normalize-path"));
var import_fast_glob = __toESM(require("fast-glob"));

// src/devtools/server.ts
var import_get_port_please = require("get-port-please");
var import_server = __toESM(require("tailwind-config-viewer/server"));

// src/constants.ts
var PLUGIN_NAME = "tailwindcss-webpack-plugin";
var COMPILE_ENTRY_PATH = new URL("./templates/_compile-entry_.js", importMetaUrl).pathname;
var TAILWIND_ENTRY_PATH = new URL("./templates/_tailwind_.css", importMetaUrl).pathname;
var DEVTOOLS_ENTRY_PATH = new URL("./templates/_tailwind-devtools_.js", importMetaUrl).pathname;
var DEVTOOLS_LOADER_PATH = new URL("./loaders/devtools-loader.js", importMetaUrl).pathname;
var CSS_LOADER_PATH = new URL("./loaders/css-loader.js", importMetaUrl).pathname;

// src/util.ts
var debug = (0, import_debug.default)(PLUGIN_NAME);
var isDev = () => process.env.NODE_ENV === "development";

// src/loaders/css-loader.ts
async function CssLoader(source) {
  this.cacheable(false);
  debug(`[css-loader]: transform ${this.resourcePath} start`);
  const callback = this.async();
  const { service, dirty } = this._compiler.$tailwind;
  await service.ensureInit();
  if (dirty.size && isDev()) {
    const { configFiles, files } = Array.from(dirty).reduce((map, file) => {
      file === "config-file" || service.configDependencies.has(file) ? map.configFiles.push(file) : map.files.push(file);
      return map;
    }, {
      configFiles: [],
      files: []
    });
    if (configFiles.length) {
      await service.refresh();
    } else {
      service.updateChangedContent(files.map((file) => {
        return {
          content: (0, import_fs.readFileSync)(file, "utf8"),
          extension: (0, import_path.extname)(file).slice(1)
        };
      }));
    }
    dirty.clear();
  }
  try {
    const result = await service.transformCSS(source);
    debug(`[css-loader]: transform ${this.resourcePath} success`);
    callback(null, result.css);
  } catch (err) {
    debug(`[css-loader]: transform ${this.resourcePath} err: 
${err}`);
    callback(err, `${source}
/* Error: ${err}*/`);
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
