var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/loaders/devtools-loader.ts
var devtools_loader_exports = {};
__export(devtools_loader_exports, {
  default: () => devtoolsLoader
});
module.exports = __toCommonJS(devtools_loader_exports);

// node_modules/.pnpm/tsup@5.12.6_postcss@8.4.12+typescript@4.6.3/node_modules/tsup/assets/cjs_shims.js
var getImportMetaUrl = () => typeof document === "undefined" ? new URL("file:" + __filename).href : document.currentScript && document.currentScript.src || new URL("main.js", document.baseURI).href;
var importMetaUrl = /* @__PURE__ */ getImportMetaUrl();

// src/loaders/devtools-loader.ts
var import_fs = require("fs");

// src/util.ts
var import_debug = __toESM(require("debug"));
var import_processTailwindFeatures = __toESM(require("tailwindcss/lib/processTailwindFeatures"));
var import_getModuleDependencies = __toESM(require("tailwindcss/lib/lib/getModuleDependencies"));
var import_resolveConfig = __toESM(require("tailwindcss/resolveConfig"));
var import_normalize_path = __toESM(require("normalize-path"));
var import_fast_glob = __toESM(require("fast-glob"));

// src/devtools/server.ts
var import_get_port_please = require("get-port-please");
var import_server = __toESM(require("tailwind-config-viewer/server"));

// src/constants.ts
var PLUGIN_NAME = "tailwindcss-webpack-plugin";
var DEVTOOLS_POST_PATH = "/_tailwindcss_devtools_update";
var COMPILE_ENTRY_PATH = new URL("./templates/_compile-entry_.js", importMetaUrl).pathname;
var TAILWIND_ENTRY_PATH = new URL("./templates/_tailwind_.css", importMetaUrl).pathname;
var DEVTOOLS_ENTRY_PATH = new URL("./templates/_tailwind-devtools_.js", importMetaUrl).pathname;
var DEVTOOLS_LOADER_PATH = new URL("./loaders/devtools-loader.js", importMetaUrl).pathname;
var CSS_LOADER_PATH = new URL("./loaders/css-loader.js", importMetaUrl).pathname;

// src/util.ts
var debug = (0, import_debug.default)(PLUGIN_NAME);
var isWebTarget = (target) => {
  let isWeb = true;
  const _isWebTarget = (checked) => !checked.includes("node") && !checked.includes("electron-preload") && !checked.includes("electron-main") && !checked.includes("nwjs");
  if (typeof target === "string") {
    isWeb = _isWebTarget(target);
  } else if (Array.isArray(target)) {
    target.forEach((checked) => {
      if (!_isWebTarget(checked)) {
        isWeb = false;
        return;
      }
    });
  }
  return isWeb;
};
var isDev = () => process.env.NODE_ENV === "development";

// src/loaders/devtools-loader.ts
var DEVTOOLS_CLIENT_PATH = new URL("../devtools/client.js", importMetaUrl);
async function devtoolsLoader(source) {
  const callback = this.async();
  if (!this._compiler) {
    callback(null, source);
    return;
  }
  this.cacheable(false);
  if (isWebTarget(this._compiler.options.target) && isDev()) {
    await this._compiler.$tailwind.service.ensureInit();
    const { port, host } = await this._compiler.$tailwind.server.ensureStart();
    debug(`[devtools-loader]: backend server started`);
    const clientContent = (0, import_fs.readFileSync)(DEVTOOLS_CLIENT_PATH, "utf-8").replace("__POST_PATH__", `http://${host}:${port}${DEVTOOLS_POST_PATH}`).replace("__CONFIG_VIEWER_PATH__", `http://${host}:${port}`);
    const completions = this._compiler.$tailwind.service.getCompletions();
    debug(`[devtools-loader]: completions generated`);
    callback(null, `${clientContent}
${completions}`);
  } else {
    callback(null, "");
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
